hdu 4283 You Are the One(区间DP)

来源:互联网 发布:kali linux安装输入法 编辑:程序博客网 时间:2024/05/29 03:31

Problem Description
  The TV shows such as You Are the One has been very popular. In order to meet the need of boys who are still single, TJUT hold the show itself. The show is hold in the Small hall, so it attract a lot of boys and girls. Now there are n boys enrolling in. At the beginning, the n boys stand in a row and go to the stage one by one. However, the director suddenly knows that very boy has a value of diaosi D, if the boy is k-th one go to the stage, the unhappiness of him will be (k-1)*D, because he has to wait for (k-1) people. Luckily, there is a dark room in the Small hall, so the director can put the boy into the dark room temporarily and let the boys behind his go to stage before him. For the dark room is very narrow, the boy who first get into dark room has to leave last. The director wants to change the order of boys by the dark room, so the summary of unhappiness will be least. Can you help him?

Input
  The first line contains a single integer T, the number of test cases. For each case, the first line is n (0 < n <= 100)
  The next n line are n integer D1-Dn means the value of diaosi of boys (0 <= Di <= 100)

Output
  For each test case, output the least summary of unhappiness .

Sample Input
2
  
5
1
2
3
4
5

5
5
4
3
2
2

Sample Output
Case #1: 20
Case #2: 24

题意:有n个人排成一排要上台表演,每个人有一个屌丝值pi。第i个上台表演的人,他的不满意度为(i-1)*pi。

现在有一个类似于栈的黑屋子,你可以让某些人进入这个黑屋子。这些人要按照排的顺序来,那么对于排在最前面的人,

就有两个选择:

(1)让他直接上台表演;

(2)让他暂时进黑屋子。

现在请你选择一个合理的调度顺序,使得最后的总不满意度最小?

思路:解题思路 :参考别人的

dp[i][j]表示区间[i,j]的最小总不开心值

把区间[i,j]单独来看,则第i个人可以是第一个出场,也可以是最后一个出场(j-i+1),也可以是在中间出场(1 ~ j-i+1)

不妨设他是第k个出场的(1<=k<=j-i+1),那么根据栈后进先出的特点,以及题目要求原先男的是排好序的,那么::

第 i+1 到 i+k-1 总共有k-1个人要比i先出栈,

第 i+k 到j 总共j-i-k+1个人在i后面出栈

举个例子吧:

有5个人事先排好顺序 1,2,3,4,5

入栈的时候,1入完2入,2入完3入,如果我要第1个人第3个出场,那么入栈出栈顺序是这样的:

1入,2入,3入,3出,2出,1出(到此第一个人就是第3个出场啦,很明显第2,3号人要在1先出,而4,5要在1后出)

这样子, 动态转移方程 就出来啦,根据第i个人是第k个出场的,将区间[i,j]分成3个部分

dp[i][j]=min(dp[i][j],dp[i+1,i+k-1]+dp[i+k,j]+(k-1)*a[i]+(sum[j]-sum[i+k-1])*k);

(sum[j]-sum[i+k-1])*k 表示 后面的 j-i-k+1个人是在i后面才出场的,那么每个人的不开心值都会加个 unhappy,sum[i]用来记录前面i个人的总不开心值,根据题目,每个人的unhappy是个 累加的过程 ,多等一个人,就多累加一次
代码:

#include<cstdio>#include<cstring>#include<algorithm>using namespace std;int sum[105],a[105],dp[105][105];int main(){    int T;    scanf("%d",&T);    for(int t=1;t<=T;t++)    {        int n;        scanf("%d",&n);        memset(sum,0,sizeof(sum));        memset(dp,0,sizeof(dp));        for(int i=1;i<=n;i++)        {            scanf("%d",&a[i]);            sum[i]=sum[i-1]+a[i];        }        for(int k=1;k<n;k++)            for(int i=1,j=i+k;j<=n;i++,j++)            {                dp[i][j]=9999999;                for(int d=1;d<=k+1;d++)                {                    dp[i][j]=min(dp[i][j],dp[i+1][i+d-1]+dp[i+d][j]+(d-1)*a[i]+(sum[j]-sum[i+d-1])*d);                }            }        printf("Case #%d: %d\n",t,dp[1][n]);    }}
0 0
原创粉丝点击